import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingCooperateLog, BookingCooperateLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商务合作留言记录
 */
export async function pageBookingCooperateLog(params: BookingCooperateLogParam) {
  const res = await request.get<ApiResult<PageResult<BookingCooperateLog>>>(
    MODULES_API_URL + '/booking/booking-cooperate-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商务合作留言记录列表
 */
export async function listBookingCooperateLog(params?: BookingCooperateLogParam) {
  const res = await request.get<ApiResult<BookingCooperateLog[]>>(
    MODULES_API_URL + '/booking/booking-cooperate-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商务合作留言记录
 */
export async function addBookingCooperateLog(data: BookingCooperateLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-cooperate-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商务合作留言记录
 */
export async function updateBookingCooperateLog(data: BookingCooperateLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-cooperate-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商务合作留言记录
 */
export async function removeBookingCooperateLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-cooperate-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商务合作留言记录
 */
export async function removeBatchBookingCooperateLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-cooperate-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商务合作留言记录
 */
export async function getBookingCooperateLog(id: number) {
  const res = await request.get<ApiResult<BookingCooperateLog>>(
    MODULES_API_URL + '/booking/booking-cooperate-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
